VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "AllplanPolyObj"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
Option Explicit
'lokale Variable(n) zum Zuweisen der Eigenschaft(en)
Private mvarstrLayer As String 'lokale Kopie
Private mvarvntPoints() As Variant  'lokale Kopie
Private mvarobjStyle As NALLCOMSERVERLib.Style  'lokale Kopie
Const intRound As Integer = 10 'Rundungswert zur berprfung von Mehrfachpunkten

Public Sub SetStyle(ByVal objStyle As Style)
    Set mvarobjStyle = objStyle
End Sub

Public Sub GetStyle(objStyle As Style)
    Set objStyle = mvarobjStyle
End Sub

Public Sub GetLayer(strLayer As String)
    strLayer = mvarstrLayer
End Sub

Public Sub SetLayer(ByVal strLayer As String)
    mvarstrLayer = strLayer
End Sub

Public Sub Getgeometry3D(vntPoints As Variant)
Dim i As Integer
Dim dblPoints3D() As Double

    For i = 0 To UBound(mvarvntPoints, 2)
        ReDim Preserve dblPoints3D(2, i)
        dblPoints3D(0, i) = mvarvntPoints(0, i)
        dblPoints3D(1, i) = mvarvntPoints(1, i)
        dblPoints3D(2, i) = mvarvntPoints(2, i)
    Next
vntPoints = dblPoints3D
End Sub

Public Sub GetGeometry2D(vntPoints As Variant)
Dim i As Integer
Dim dblPoints2D() As Double

    For i = 0 To UBound(mvarvntPoints, 2)
        ReDim Preserve dblPoints2D(1, i)
        dblPoints2D(0, i) = mvarvntPoints(0, i)
        dblPoints2D(1, i) = mvarvntPoints(1, i)
    Next
vntPoints = dblPoints2D
End Sub

Public Sub SetGeometry(ByVal vntPoints As Variant)
Dim i As Integer

    If UBound(vntPoints, 1) = 1 Then
        For i = 0 To UBound(vntPoints, 2)
            ReDim Preserve mvarvntPoints(2, i)
            mvarvntPoints(0, i) = vntPoints(0, i)
            mvarvntPoints(1, i) = vntPoints(1, i)
            mvarvntPoints(2, i) = CDbl(0)
        Next
    ElseIf UBound(vntPoints, 1) = 2 Then
        For i = 0 To UBound(vntPoints, 2)
            ReDim Preserve mvarvntPoints(2, i)
            mvarvntPoints(0, i) = vntPoints(0, i)
            mvarvntPoints(1, i) = vntPoints(1, i)
            mvarvntPoints(2, i) = vntPoints(2, i)
        Next
    End If
End Sub

Public Sub ClosePoly()
Dim i As Long

    i = UBound(mvarvntPoints, 2)
    If i > 1 Then
        If mvarvntPoints(0, 0) <> mvarvntPoints(0, i) Or mvarvntPoints(1, 0) <> mvarvntPoints(1, i) _
        Or mvarvntPoints(2, 0) <> mvarvntPoints(2, i) Then
            ReDim Preserve mvarvntPoints(2, i + 1)
            mvarvntPoints(0, i + 1) = mvarvntPoints(0, 0)
            mvarvntPoints(1, i + 1) = mvarvntPoints(1, 0)
            mvarvntPoints(2, i + 1) = mvarvntPoints(2, 0)
        End If
    End If
End Sub

Public Sub OpenPoly()
Dim i As Long

    i = UBound(mvarvntPoints, 2)
    If i > 1 Then
        If mvarvntPoints(0, 0) = mvarvntPoints(0, i) And mvarvntPoints(1, 0) = mvarvntPoints(1, i) _
        And mvarvntPoints(2, 0) = mvarvntPoints(2, i) Then
            ReDim Preserve mvarvntPoints(2, i - 1)
        End If
    End If
End Sub

Public Sub ZValue(dblZValue As Double)
Dim i As Long

    For i = 0 To UBound(mvarvntPoints, 2)
        mvarvntPoints(2, i) = dblZValue
    Next
End Sub

Public Sub RemoveMultiPoints2D()
Dim vntTemp() As Variant
Dim i As Long
Dim j As Long
    
    ReDim vntTemp(2, j)
    vntTemp(0, j) = mvarvntPoints(0, 0)
    vntTemp(1, j) = mvarvntPoints(1, 0)
    vntTemp(2, j) = mvarvntPoints(2, 0)
    
    For i = 1 To UBound(mvarvntPoints, 2)
        If Round(vntTemp(0, j), intRound) = Round(mvarvntPoints(0, i), intRound) And _
           Round(vntTemp(1, j), intRound) = Round(mvarvntPoints(1, i), intRound) Then
        
        Else
            j = j + 1
            ReDim Preserve vntTemp(2, j)
            vntTemp(0, j) = mvarvntPoints(0, i)
            vntTemp(1, j) = mvarvntPoints(1, i)
            vntTemp(2, j) = mvarvntPoints(2, i)
       End If
    Next
    mvarvntPoints = vntTemp
End Sub

Public Sub RemoveMultiPoints3D()
Dim vntTemp() As Variant
Dim i As Long
Dim j As Long
    
    ReDim vntTemp(2, j)
    vntTemp(0, j) = mvarvntPoints(0, 0)
    vntTemp(1, j) = mvarvntPoints(1, 0)
    vntTemp(2, j) = mvarvntPoints(2, 0)
    
    For i = 1 To UBound(mvarvntPoints, 2)
        If Round(vntTemp(0, j), intRound) = Round(mvarvntPoints(0, i), intRound) And _
           Round(vntTemp(1, j), intRound) = Round(mvarvntPoints(1, i), intRound) And _
           Round(vntTemp(2, j), intRound) = Round(mvarvntPoints(2, i), intRound) Then
        Else
            j = j + 1
            ReDim Preserve vntTemp(2, j)
            vntTemp(0, j) = mvarvntPoints(0, i)
            vntTemp(1, j) = mvarvntPoints(1, i)
            vntTemp(2, j) = mvarvntPoints(2, i)
       End If
    Next
    mvarvntPoints = vntTemp
End Sub

Public Sub ReversePoly()
Dim vntTemp() As Variant
Dim i As Long
Dim j As Long

    j = UBound(mvarvntPoints, 2)
    ReDim vntTemp(2, j)
    For i = 0 To UBound(mvarvntPoints, 2)
        vntTemp(0, i) = mvarvntPoints(0, j - i)
        vntTemp(1, i) = mvarvntPoints(1, j - i)
        vntTemp(2, i) = mvarvntPoints(2, j - i)
    Next
    mvarvntPoints = vntTemp
End Sub

Public Function AllPointsInLine() As Boolean
Dim blnPIL As Boolean
Dim i As Long
Dim m1 As Double
Dim m2 As Double
Dim lngE As Long

    lngE = UBound(mvarvntPoints, 2)
    
    If mvarvntPoints(0, 0) = mvarvntPoints(0, UBound(mvarvntPoints, 2)) _
    And mvarvntPoints(1, 0) = mvarvntPoints(1, UBound(mvarvntPoints, 2)) Then _
        lngE = lngE - 1

    If mvarvntPoints(0, 0) - mvarvntPoints(0, lngE) = 0 Then
        m1 = 1
    Else
        m1 = (mvarvntPoints(1, 0) - mvarvntPoints(1, lngE)) / (mvarvntPoints(0, 0) - mvarvntPoints(0, lngE))
    End If
    
    blnPIL = True
    
    Do While blnPIL = True And i < lngE
        If mvarvntPoints(0, i + 1) - mvarvntPoints(0, i) = 0 Then
            m2 = 1
        Else
            m2 = Abs((mvarvntPoints(1, i + 1) - mvarvntPoints(1, i)) / (mvarvntPoints(0, i + 1) - mvarvntPoints(0, i)))
        End If
        If Round(m1, 15) <> Round(m2, 15) Then blnPIL = False
        i = i + 1
    Loop
AllPointsInLine = blnPIL
End Function

Public Function Count() As Long
    Count = UBound(mvarvntPoints, 2)
End Function

Private Sub Class_Initialize()
    ReDim mvarvntPoints(2, 1)
    mvarstrLayer = "STANDARD"
    Set mvarobjStyle = New NALLCOMSERVERLib.Style
End Sub
