VERSION 5.00
Begin VB.Form frmAllplanPoly 
   BorderStyle     =   1  'Fest Einfach
   Caption         =   "Allplan Flchen v0.9.2"
   ClientHeight    =   2415
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   3855
   Icon            =   "frmAllplanPoly.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   2415
   ScaleWidth      =   3855
   StartUpPosition =   3  'Windows-Standard
   Begin VB.Frame fraModi 
      Caption         =   "Geometrie-Modifizierung:"
      Height          =   855
      Left            =   120
      TabIndex        =   18
      Top             =   1440
      Width           =   2415
      Begin VB.CheckBox chkZValue 
         Caption         =   "Z-Wert"
         Height          =   195
         Left            =   1440
         TabIndex        =   11
         ToolTipText     =   " Modifiziert Z-Wert "
         Top             =   240
         Width           =   855
      End
      Begin VB.CheckBox chkClosePoly 
         Caption         =   "P. schliessen"
         Height          =   195
         Left            =   120
         TabIndex        =   9
         ToolTipText     =   " Schliesst offene Polygonzge "
         Top             =   240
         Width           =   1335
      End
      Begin VB.CheckBox chkDividePoly 
         Caption         =   "P. zerlegen"
         Height          =   195
         Left            =   120
         TabIndex        =   10
         ToolTipText     =   " Zerlegt Polygonzge in Einzelelemente "
         Top             =   500
         Width           =   1095
      End
      Begin VB.TextBox txtZValue 
         Alignment       =   2  'Zentriert
         Height          =   285
         Left            =   1440
         TabIndex        =   12
         ToolTipText     =   " Absoluter Z-Wert in Meter "
         Top             =   480
         Width           =   855
      End
   End
   Begin VB.CommandButton cmdCancel 
      Caption         =   "Abbruch"
      Height          =   375
      Left            =   2640
      TabIndex        =   14
      Top             =   1440
      Width           =   1095
   End
   Begin VB.Frame fraStyle 
      Caption         =   "Formatdefinition:"
      Height          =   1215
      Left            =   1560
      TabIndex        =   16
      Top             =   120
      Width           =   2175
      Begin VB.TextBox txtColor 
         Alignment       =   2  'Zentriert
         Height          =   285
         Left            =   1320
         MaxLength       =   3
         TabIndex        =   8
         ToolTipText     =   "Farb-Nummer (0-255) "
         Top             =   840
         Width           =   735
      End
      Begin VB.CheckBox chkLayer 
         Caption         =   "Layer"
         Height          =   195
         Left            =   120
         TabIndex        =   6
         ToolTipText     =   " Erstellt Elemente auf dem angegebenen Layer "
         Top             =   600
         Width           =   1095
      End
      Begin VB.TextBox txtLayer 
         Alignment       =   2  'Zentriert
         Height          =   285
         Left            =   120
         MaxLength       =   8
         TabIndex        =   7
         ToolTipText     =   " Layerkurzname "
         Top             =   840
         Width           =   1095
      End
      Begin VB.OptionButton optOriginStyle 
         Caption         =   "Original"
         Height          =   195
         Left            =   1200
         TabIndex        =   5
         ToolTipText     =   " Erstellt Elemente mit Formatdefinition des Originals "
         Top             =   240
         Width           =   855
      End
      Begin VB.OptionButton optActiveStyle 
         Caption         =   "Aktuell"
         Height          =   195
         Left            =   120
         TabIndex        =   4
         ToolTipText     =   " Erstellt Elemente mit aktiver Formatdefinition "
         Top             =   240
         Width           =   855
      End
      Begin VB.Label lbColor 
         Caption         =   "Fllflche"
         Height          =   255
         Left            =   1320
         TabIndex        =   17
         Top             =   600
         Width           =   735
      End
   End
   Begin VB.Frame fraPolyObj 
      Caption         =   "Element:"
      Height          =   1215
      Left            =   120
      TabIndex        =   15
      ToolTipText     =   " Zu erstelende Elemente "
      Top             =   120
      Width           =   1335
      Begin VB.OptionButton optCadSurface 
         Caption         =   "3D Flche"
         Height          =   195
         Left            =   120
         TabIndex        =   3
         Top             =   960
         Width           =   1140
      End
      Begin VB.OptionButton optFilling 
         Caption         =   "Fllflche"
         Height          =   195
         Left            =   120
         TabIndex        =   1
         Top             =   480
         Width           =   1140
      End
      Begin VB.OptionButton optPolyLine3D 
         Caption         =   "3D Polylinie"
         Height          =   195
         Left            =   120
         TabIndex        =   2
         Top             =   720
         Width           =   1140
      End
      Begin VB.OptionButton optPolyLine 
         Caption         =   "PolyLinie"
         Height          =   195
         Left            =   120
         TabIndex        =   0
         Top             =   240
         Width           =   1140
      End
   End
   Begin VB.CommandButton cmdPolyObj 
      Caption         =   "... erstellen"
      Default         =   -1  'True
      Height          =   375
      Left            =   2640
      TabIndex        =   13
      Top             =   1920
      Width           =   1095
   End
End
Attribute VB_Name = "frmAllplanPoly"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Public GstrLayer As String
Public GlngColor As Long
Public GobjStyle As NALLCOMSERVERLib.Style
Public GlngPolyObj As Long
Public GblnActiveStyle As Boolean
Public GblnActiveLayer As Boolean
Public GblnClosePoly As Boolean
Public GblnDividePoly As Boolean
Public GblnZValue As Boolean
Public GdblZValue As Double

Public Enum PolyObj
    PolyLine = 0
    Filling = 1
    PolyLine3D = 2
    CadSurface = 3
End Enum

Private Declare Function SetWindowPos Lib "User32" (ByVal hWnd As Long, ByVal hWndInsertAfter As Long, ByVal x As Long, ByVal y As Long, ByVal cx As Long, ByVal cy As Long, ByVal wFlags As Long) As Long

'OnTop
Private Sub SetTop(hWnd As Long, Top As Boolean)
    If Top = True Then
    SetWindowPos hWnd, -1, 0, 0, 0, 0, 3
    Else
    SetWindowPos hWnd, -2, 0, 0, 0, 0, 3
    End If
End Sub
Private Sub frmTop()
    SetTop Me.hWnd, True
End Sub
Private Sub frmUnTop()
    SetTop Me.hWnd, False
End Sub

Private Sub cmdPolyObj_Click()
    If CheckAllplan = False Then Exit Sub
    ValidateSettings
    SetPublicVariable
    CreatePolyObject
End Sub
Function CheckAllplan() As Boolean
Dim objApplication As NALLCOMSERVERLib.AllplApplication
    
    On Error GoTo Fehler
    Set objApplication = New NALLCOMSERVERLib.AllplApplication
    CheckAllplan = True
    Exit Function
Fehler:
    CheckAllplan = False
End Function

Sub SetPublicVariable()

    GstrLayer = txtLayer.Text
    GlngColor = txtColor.Text
    Set GobjStyle = GetActiveStyle
    GdblZValue = CDbl(txtZValue.Text) * 1000
    
    If optActiveStyle.Value = True Then
        GblnActiveStyle = True
    Else
        GblnActiveStyle = False
    End If
    
    If chkLayer.Value = 1 Then
        GblnActiveLayer = True
    Else
        GblnActiveLayer = False
    End If
    
    If chkClosePoly.Value = 1 Then
        GblnClosePoly = True
    Else
        GblnClosePoly = False
    End If
    
    If chkDividePoly.Value = 1 Then
        GblnDividePoly = True
    Else
        GblnDividePoly = False
    End If
    
    If chkZValue.Value = 1 Then
        GblnZValue = True
    Else
        GblnZValue = False
    End If
    
End Sub

Private Sub cmdCancel_Click()
    Unload Me
End Sub
Private Sub LayerValidate(txtBox As TextBox)
Dim objAllplanLayer As NALLCOMSERVERLib.Layer
Dim strValue As String
    
    On Error GoTo Fehler
    Set objAllplanLayer = New NALLCOMSERVERLib.Layer
    txtBox.Text = UCase(txtBox.Text)
    strValue = txtBox.Text
    objAllplanLayer.InitializeByAbbreviation CStr(strValue)
    Exit Sub
Fehler:
    If Error = "Layer.InitializeByAbbreviation: Abbreviation does not exist" Then
        'MsgBox "Bitte Layername berprfen", vbCritical, "Eingabefehler"
        txtBox.Text = "STANDARD"
        TextBoxFocus txtBox
    End If
End Sub
Private Sub IntegerValidate(txtBox As TextBox, Optional intMinValue As Integer = -32767, Optional intMaxValue As Integer = 32767)
Dim strValue As String
    strValue = Replace(txtBox.Text, ",", ".")
    If IsNumeric(strValue) = True Then
        If CInt(strValue) < intMinValue = True Or CInt(strValue) > intMaxValue = True Then strValue = "1"
        txtBox.Text = Format(CInt(strValue), "0")
    Else
        strValue = "1"
        txtBox.Text = Format(CInt(strValue), "0")
    End If
End Sub
Private Sub DoubleValidate(txtBox As TextBox, Optional dblMinValue As Double = -999999999, _
    Optional dblMaxValue As Double = 999999999, Optional strFormat As String = "0.000")
Dim strValue As String
Dim sc As Object

    On Error Resume Next
    Set sc = CreateObject("scriptcontrol")
    sc.Language = "VBScript"
    
    strValue = Replace(txtBox.Text, ",", ".")
    strValue = sc.Eval(strValue)

    If IsNumeric(strValue) = True Then
        If CDbl(strValue) < dblMinValue = True Or CDbl(strValue) > dblMaxValue = True Then strValue = "0"
        txtBox.Text = Format(CDbl(strValue), strFormat)
    Else
        strValue = "0"
        txtBox.Text = Format(CDbl(strValue), strFormat)
    End If
End Sub
Private Sub TextBoxFocus(txtBox As TextBox)
    With txtBox
        .SetFocus
        .SelStart = 0
        .SelLength = Len(.Text)
    End With
End Sub
Private Sub CheckBoxEnabled(chkBox As CheckBox, obj As Object)
    If chkBox = 1 Then
        obj.Enabled = True
    Else
        obj.Enabled = False
    End If
End Sub

Private Sub SaveSettings()
    On Error Resume Next
    
    SaveSetting "AllplanTools", "AllplanPoly", "PolyObj", GlngPolyObj
    SaveSetting "AllplanTools", "AllplanPoly", "ActiveStyle", CInt(optActiveStyle.Value)
    SaveSetting "AllplanTools", "AllplanPoly", "modClosePoly", CStr(chkClosePoly.Value)
    SaveSetting "AllplanTools", "AllplanPoly", "modDividePoly", CStr(chkDividePoly.Value)
    SaveSetting "AllplanTools", "AllplanPoly", "modZValue", CStr(chkZValue.Value)
    SaveSetting "AllplanTools", "AllplanPoly", "ZValue", CStr(txtZValue.Text)
    SaveSetting "AllplanTools", "AllplanPoly", "Layer", CStr(chkLayer.Value)
    SaveSetting "AllplanTools", "AllplanPoly", "Layername", CStr(txtLayer.Text)
    SaveSetting "AllplanTools", "AllplanPoly", "Color", CStr(txtColor.Text)
    SaveSetting "AllplanTools", "AllplanPoly", "Left", CStr(Me.Left)
    SaveSetting "AllplanTools", "AllplanPoly", "Top", CStr(Me.Top)
End Sub

Private Sub LoadSettings()
    On Error Resume Next
    
    GlngPolyObj = GetSetting("AllplanTools", "AllplanPoly", "PolyObj", 0)
    optActiveStyle.Value = GetSetting("AllplanTools", "AllplanPoly", "ActiveStyle", 1)
    chkClosePoly.Value = GetSetting("AllplanTools", "AllplanPoly", "modClosePoly", 0)
    chkDividePoly.Value = GetSetting("AllplanTools", "AllplanPoly", "modDividePoly", 0)
    chkZValue.Value = GetSetting("AllplanTools", "AllplanPoly", "modZValue", 0)
    txtZValue.Text = GetSetting("AllplanTools", "AllplanPoly", "ZValue", "0")
    chkLayer.Value = GetSetting("AllplanTools", "AllplanPoly", "Layer", 0)
    txtLayer.Text = GetSetting("AllplanTools", "AllplanPoly", "Layername", "STANDARD")
    txtColor.Text = GetSetting("AllplanTools", "AllplanPoly", "Color", "1")
    Me.Left = GetSetting("AllplanTools", "AllplanPoly", "Left", 1500)
    Me.Top = GetSetting("AllplanTools", "AllplanPoly", "Top", 1500)
    
    If optActiveStyle.Value = False Then optOriginStyle.Value = True
    
End Sub
Private Sub PolyObjSettings()
    Select Case GlngPolyObj
        Case 0
            optPolyLine.Value = True
        Case 1
            optFilling.Value = True
        Case 2
            optPolyLine3D.Value = True
        Case 3
            optCadSurface = True
        Case Else
            optPolyLine.Value = True
    End Select
End Sub
Private Sub ValidateSettings()
    Call txtLayer_Validate(False)
    Call txtColor_Validate(False)
    Call txtZValue_Validate(False)
End Sub
Private Sub EnabledInit()
    CheckBoxEnabled chkLayer, txtLayer
    CheckBoxEnabled chkZValue, txtZValue
End Sub

Private Sub Form_Load()
    LoadSettings
    EnabledInit
    PolyObjSettings
    ValidateSettings
    frmTop
End Sub

Private Sub Form_Unload(Cancel As Integer)
    SaveSettings
End Sub

Private Sub optCadSurface_Click()
    GlngPolyObj = PolyObj.CadSurface
End Sub

Private Sub optFilling_Click()
    GlngPolyObj = PolyObj.Filling
End Sub

Private Sub optPolyLine_Click()
    GlngPolyObj = PolyObj.PolyLine
End Sub

Private Sub optPolyLine3D_Click()
    GlngPolyObj = PolyObj.PolyLine3D
End Sub

Private Sub txtColor_GotFocus()
    TextBoxFocus txtColor
End Sub

Private Sub txtColor_Validate(Cancel As Boolean)
    IntegerValidate txtColor, 0, 255
End Sub

Private Sub txtLayer_GotFocus()
    TextBoxFocus txtLayer
End Sub

Private Sub txtLayer_Validate(Cancel As Boolean)
    LayerValidate txtLayer
End Sub

Private Sub txtZValue_GotFocus()
    TextBoxFocus txtZValue
End Sub

Private Sub txtZValue_Validate(Cancel As Boolean)
    DoubleValidate txtZValue, -99999999, 99999999, "0.000"
End Sub

Private Sub chkLayer_Click()
    CheckBoxEnabled chkLayer, txtLayer
End Sub
Private Sub chkZvalue_Click()
    CheckBoxEnabled chkZValue, txtZValue
End Sub

