Attribute VB_Name = "modAllplanStyle"
Option Explicit

'Liesst den aktuellen Style aus
Function GetActiveStyle() As NALLCOMSERVERLib.Style
Dim objApplication As NALLCOMSERVERLib.AllplApplication
Dim objStyle As NALLCOMSERVERLib.Style
    
    On Error GoTo Fehler
    Set objApplication = New NALLCOMSERVERLib.AllplApplication
    Set objStyle = objApplication.ActiveDocument.CadElements.ActiveStyle
    Set GetActiveStyle = objStyle
Fehler:
    If Error = "AllplApplication.FinalConstruct: programm is in menue interaction, to continue terminate menueinteraction" Then
        MsgBox "Bitte Funktion in Allplan beenden", vbCritical, "Fehler"
    End If
End Function

'Layer lesen
Sub SetLayer(objCadElement As NALLCOMSERVERLib.CadElement, ByVal strLayer As String)
    objCadElement.Layer.InitializeByAbbreviation strLayer
End Sub

'Layer schreiben
Function GetLayer(objCadElement As NALLCOMSERVERLib.CadElement) As String
    GetLayer = objCadElement.Layer.Abbreviation
End Function

'Style lesen
Function GetStyle(ByVal objCadElement As NALLCOMSERVERLib.CadElement) As NALLCOMSERVERLib.Style
Dim objLine2D As NALLCOMSERVERLib.Line2D
Dim objEllipse2D As NALLCOMSERVERLib.Ellipse2D
Dim objPolyLine As NALLCOMSERVERLib.PolyLine
Dim objPolyLine3D As NALLCOMSERVERLib.PolyLine3D
Dim objCadSurface As NALLCOMSERVERLib.CadSurface
Dim objSolid As NALLCOMSERVERLib.Solid
Dim objHatch As NALLCOMSERVERLib.Hatch
Dim objPattern As NALLCOMSERVERLib.Pattern
Dim objParagraph As NALLCOMSERVERLib.Paragraph
Dim objStyle As NALLCOMSERVERLib.Style
 
    If TypeOf objCadElement Is NALLCOMSERVERLib.Line2D Then
        Set objLine2D = objCadElement
        Set objStyle = objLine2D.Style
    ElseIf TypeOf objCadElement Is NALLCOMSERVERLib.Ellipse2D Then
        Set objEllipse2D = objCadElement
        Set objStyle = objEllipse2D.Style
    ElseIf TypeOf objCadElement Is NALLCOMSERVERLib.PolyLine Then
        Set objPolyLine = objCadElement
        Set objStyle = objPolyLine.Style
    ElseIf TypeOf objCadElement Is NALLCOMSERVERLib.PolyLine3D Then
        Set objPolyLine3D = objCadElement
        Set objStyle = objPolyLine3D.Style
    ElseIf TypeOf objCadElement Is NALLCOMSERVERLib.CadSurface Then
        Set objCadSurface = objCadElement
        Set objStyle = objCadSurface.Style
    ElseIf TypeOf objCadElement Is NALLCOMSERVERLib.Solid Then
        Set objSolid = objCadElement
        Set objStyle = objSolid.Style
    ElseIf TypeOf objCadElement Is NALLCOMSERVERLib.Filling Then
        Set objStyle = New NALLCOMSERVERLib.Style
    ElseIf TypeOf objCadElement Is NALLCOMSERVERLib.Hatch Then
        Set objHatch = objCadElement
        Set objStyle = objHatch.Style
    ElseIf TypeOf objCadElement Is NALLCOMSERVERLib.Pattern Then
        Set objPattern = objCadElement
        Set objStyle = objPattern.Style
    ElseIf TypeOf objCadElement Is NALLCOMSERVERLib.Paragraph Then
        Set objParagraph = objCadElement
        Set objStyle = objParagraph.Style
    End If
    
    Set GetStyle = objStyle
End Function

'Style schreiben
Sub SetStyle(objCadElement As NALLCOMSERVERLib.CadElement, objStyle As NALLCOMSERVERLib.Style)
Dim objLine2D As NALLCOMSERVERLib.Line2D
Dim objEllipse2D As NALLCOMSERVERLib.Ellipse2D
Dim objPolyLine As NALLCOMSERVERLib.PolyLine
Dim objPolyLine3D As NALLCOMSERVERLib.PolyLine3D
Dim objCadSurface As NALLCOMSERVERLib.CadSurface
Dim objSolid As NALLCOMSERVERLib.Solid
Dim objHatch As NALLCOMSERVERLib.Hatch
Dim objPattern As NALLCOMSERVERLib.Pattern
Dim objParagraph As NALLCOMSERVERLib.Paragraph
 
    If TypeOf objCadElement Is NALLCOMSERVERLib.Line2D Then
        Set objLine2D = objCadElement
        objLine2D.Style = objStyle
    ElseIf TypeOf objCadElement Is NALLCOMSERVERLib.Ellipse2D Then
        Set objEllipse2D = objCadElement
        objEllipse2D.Style = objStyle
    ElseIf TypeOf objCadElement Is NALLCOMSERVERLib.PolyLine Then
        Set objPolyLine = objCadElement
        objPolyLine.Style = objStyle
    ElseIf TypeOf objCadElement Is NALLCOMSERVERLib.PolyLine3D Then
        Set objPolyLine3D = objCadElement
        objPolyLine3D.Style = objStyle
    ElseIf TypeOf objCadElement Is NALLCOMSERVERLib.CadSurface Then
        Set objCadSurface = objCadElement
        objCadSurface.Style = objStyle
    ElseIf TypeOf objCadElement Is NALLCOMSERVERLib.Solid Then
        Set objSolid = objCadElement
        objSolid.Style = objStyle
    ElseIf TypeOf objCadElement Is NALLCOMSERVERLib.Filling Then
        '
    ElseIf TypeOf objCadElement Is NALLCOMSERVERLib.Hatch Then
        Set objHatch = objCadElement
        objHatch.Style = objStyle
    ElseIf TypeOf objCadElement Is NALLCOMSERVERLib.Pattern Then
        Set objPattern = objCadElement
        objPattern.Style = objStyle
    ElseIf TypeOf objCadElement Is NALLCOMSERVERLib.Paragraph Then
        Set objParagraph = objCadElement
        objParagraph.Style = objStyle
    End If
End Sub


